device_type: ava
job_name: AVA platform deploy and boot test
visibility: public
timeouts:
  job:
    minutes: 60
  action:
    minutes: 60
  connection:
    minutes: 2

actions:

- deploy:
    to: downloads
    images:
      os:
        url: https://people.linaro.org/~antonio.terceiro/ewaol/ewaol-baremetal-image-ava-20221019140441.rootfs.wic.bz2
        compression: bz2
        partition: 1
        format: ext4
        overlays:
          lava: true

- boot:
    timeout:
      minutes: 5
    method: minimal

- test:
    timeout:
      minutes: 5
    interactive:
    - name: enter-uefi
      script:
        - command:
      prompts:
        - 'Press ESC'
        - 'Press ESCAPE'
        - 'Press ESCAPE for boot options'
        - 'for boot options'
    - name: enter-uefi
      script:
        - command: "\x1B" # ESC
      prompts: ["Device Manager"]
    - name: enter-boot-manager
      script:
        - delay: 1
        - command: "\x1b[B\x1b[B\r\n" # Down, Down, Enter
      prompts: ["Boot Manager Menu"]
    - name: enter-uefi-shell
      script:
        - delay: 1
        - command: "\r\n" # Enter
      prompts: ["Shell>"]
    - name: boot-recovery
      script:
        - delay: 1
        - command: "FS0:\\EFI\\debian\\shimaa64.efi\r\n"
      prompts: ["Booting"]

# Boot into recovery image
- boot:
    timeout:
      minutes: 5
    method: minimal
    reset: false
    parameters:
      kernel-start-message: "EFI stub: Booting Linux Kernel"
    auto_login:
      login_prompt: 'login:'
      username: "root"
    prompts:
      - 'root@recovery:'

- test:
    timeout:
      minutes: 15
    interactive:
      - name: flash
        script:
          - command: "sleep 5" # FIXME wait for network some other way
          - command: "ava-flash /dev/nvme0n1 http://{SERVER_IP}/tmp/{JOB_ID}/downloads/common/ewaol-baremetal-image-ava-20221019140441.rootfs.wic"
        prompts: ["root@recovery:"]
      - name: reboot
        script:
          - command: "reboot"
        prompts: ["reboot:"]

# Boot into image under test
- boot:
    timeout:
      minutes: 5
    method: minimal
    reset: false
    auto_login:
      login_prompt: 'login:'
      username: "root"
    prompts:
      - 'root@ava:'

- test:
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: smoke-tests
            description: "A few basic commands"
            os:
              - linux-any
            scope:
              - functional
          run:
            steps:
              - lava-test-case "date" --shell date
              - lava-test-case "whoami" --shell whoami
              - lava-test-case "true" --shell true
        from: inline
        path: smoke-tests
        name: smoke-tests
